/* coda.h: struttura di dati "coda" realizzata mediante liste (R. Grossi, 2013) */

/* se non e' gia' definito, definiere bool */
#ifndef _BOOL_TYPE_
#define _BOOL_TYPE_
typedef enum { false = 0, true = 1} bool;
#endif

/* coda di oggetti di tipo elemento, cambiare questa definizone per cambiare il tipo degli oggetti */
#ifndef _ELEMENTO_TYPE_
#define _ELEMENTO_TYPE_
typedef int elemento; 
#define ELEMENTO_PRINTF "%d "
#endif

#ifndef _CODA_H
#define _CODA_H

/* nodo della coda */ 
typedef struct item {
  elemento dato;
  struct item *succ;
} nodo;

/* descrittore della coda, per poter creare e gestire piu' code simultaneamente */
typedef struct {
  int dimensione;
  nodo *testa;
  nodo *fondo;
} coda;

/* operazioni supportate, le uniche permesse! */
coda *Create( );
coda *Destroy( coda * );
void Enqueue( coda *, elemento );
elemento Dequeue( coda * );
elemento First( coda * );
bool Empty( coda * );
void Print( coda * );

#endif
